/******************************************************************************
 * $Id: TRListView.cpp
 *
 * Authors:
 *		Fredrik Modéen <fredrik@modeen.se>
 *
 * Copyright (c) 2005-2007 Transmission authors and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *****************************************************************************/

#include "TRColumn.h"
#include "TRField.h"

#include <TranslationUtils.h>

#include <stdio.h>

TRColumn::TRColumn(const char *title, float width, 
		float minWidth, float maxWidth) 
	: BBitmapColumn(title, width, minWidth, maxWidth)
{
}

TRColumn::~TRColumn()
{	
}

void TRColumn::AddBitmapState(uint32 state, BBitmap* bitmap)
{
	fHashMap[state] = bitmap;	
}

uint32 TRColumn::CheckState(uint32 state)
{	
	hash_map<uint32, BBitmap*>::size_type ant;
	uint32 temp;
	ant = fHashMap.size();
	if(ant <= state){
		printf("End \n");
		temp = 0;
	}else{
		printf("Adding \n");
		temp = state;
	}
	return temp;
}

BBitmap* TRColumn::GetBitmapFromState(uint32 state)
{
//	assert(key.c_str() != NULL);

	if (fHashMap.empty())
		return NULL;
	
	if (fHashMap.find(state) == fHashMap.end())
		return NULL;

	return fHashMap[state];
}

BBitmap* TRColumn::GetStartBitmap()
{
	return 	GetBitmapFromState(0);
}

void TRColumn::MouseDown(BColumnListView *parent, BRow *row, BField *field,
	BRect field_rect, BPoint point, uint32 buttons)
{
//	printf("I'm in\n");
	TRField *bitmapField = static_cast<TRField *>(field);
//	BBitmap * bitmap;

	uint32 state = bitmapField->State();
//	printf("state = %d\n", state);
//	state = CheckState(state+1);
//	printf("Check state = %d\n", state);
	bitmapField->SetState(CheckState(state+1));
//	printf("state after = %d\n", state);
//	bitmap = GetBitmapFromState(state);
		
//	if(bitmap != NULL)
	bitmapField->SetBitmap(GetBitmapFromState(state));
}
