/******************************************************************************
 * $Id: TRInfoWindow.h 2549 2007-07-30 13:59:23Z charles $
 *
 * Authors:
 *		charles
 *		Fredrik Modéen <fredrik@modeen.se>
 *
 * Copyright (c) 2005-2007 Transmission authors and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *****************************************************************************/
 
#ifndef TR_INFO_WIND
#define TR_INFO_WIND

#include <Box.h>
#include <Window.h>
#include <StringView.h>

#include <Button.h>
#include <TextControl.h>
#include <TabView.h>
#include <View.h>
#include <String.h>
#include <ScrollView.h>
#include <ListView.h>

#include "libhaiku/ColumnListView.h"
#include "libhaiku/ColumnTypes.h"

#include "TRColumn.h"
#include "TRField.h"

#include <libtransmission/transmission.h>

class TRInfoWindow : public BWindow {
public:
	TRInfoWindow(const tr_stat_t *status, const tr_info_t *info, const tr_torrent_t *torrentRef,const char *folder);
	~TRInfoWindow();
	virtual void FrameResized(float width, float height);
	virtual void MessageReceived(BMessage *msg);

private:
	void StringForFileSize(uint64_t size, BString *str);
	void CreatePeersList(const tr_torrent_t *torrentRef);
	void CreateFileList(const tr_info_t *info);
	void ReadPrefs();
	void SetDefaults();
	bool WritePrefs();

	BBox *_boxInfo, *_boxActivity, *_boxPeers, *_boxFiles, *_boxOptions;
	BTabView *_tabView;
	BView *_options, *_Info, *_activity, *_peers, *_files, *_trprefview;
	BListView *_fileListView;
	BColumnListView *fColumnList, *fColumnListTab2;
	TRColumn *fTRColumView0, *fTRColumView1, *fTRColumView2;
};

#endif
