/******************************************************************************
 * $Id: TRListView.cpp
 *
 * Authors:
 *		Fredrik Modéen <fredrik@modeen.se>
 *
 * Copyright (c) 2005-2007 Transmission authors and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *****************************************************************************/

#include "TRListView.h"
#include "TRApplication.h"

#include <stdio.h>

TRListView::TRListView(BRect  frame, const char *name) 
	: BListView(frame, name, B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL)
{
	//popupmenu = ((TRApplication *)be_app)->GetWindow()->GetTorrentMenu();
}

TRListView::~TRListView()
{	
	if (popupmenu != NULL)
		delete popupmenu;
}


void TRListView::MessageReceived(BMessage *msg) {
//	msg->PrintToStream();
//	TRWindow *window = ((TRApplication *)be_app)->GetWindow();
	switch(msg->what){
		case TR_INFO: {
			((TRApplication *)be_app)->GetWindow()->GetTorrentInfo();
		}break;
		case TR_RESUME: {
			((TRApplication *)be_app)->GetWindow()->ResumeTorrent();
		}break; 
		case TR_PAUSE:{
			((TRApplication *)be_app)->GetWindow()->PauseTorrent();
		}break; 
		case TR_REMOVE: {
			((TRApplication *)be_app)->GetWindow()->RemoveTorrent();
		}break;
		default: {
			//msg->PrintToStream();
			BListView::MessageReceived(msg);
		}break;
	}
}


void TRListView::MouseDown(BPoint point)
{
	int32 selection = BListView::IndexOf(point);
	//printf("selection was %d\n", selection);
	if(selection != -1){
		BPoint cursor;
		uint32 buttons;
		BListView::Select(selection);
		MakeFocus(true);
		GetMouse(&cursor, &buttons, true);
/*		if (buttons & B_SECONDARY_MOUSE_BUTTON) {
			BListView::ConvertToScreen(&point);
			popupmenu->Go(point, true, false, true);
		}*/
		((TRApplication *)be_app)->GetWindow()->UpdateList(selection, true, popupmenu);
	}
}
