
/******************************************************************************
 * $Id: TRListView.h
 *
 * Authors:
 *		Fredrik Modéen <fredrik@modeen.se>
 *
 * Copyright (c) 2005-2007 Transmission authors and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *****************************************************************************/

#ifndef TR_LIST_VIEW
#define TR_LIST_VIEW

#include <ListView.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <MenuField.h>
#include <PopUpMenu.h>

#include "TRDefault.h"

class TRListView : public BListView {
public:
	TRListView(BRect frame, const char *name);
	~TRListView();
	virtual void MessageReceived(BMessage *msg);
	virtual void MouseDown(BPoint where);
private:
		BPopUpMenu *popupmenu;
		BMenuItem *mode1, *mode2, *preferences, *about;
};

#endif
