/******************************************************************************
 * $Id: TRPrefsWindow.h 261 2006-05-29 21:27:31Z titer $
 *
 * Authors:
 *		titer
 *		Fredrik Modéen <fredrik@modeen.se>
 *
 * Copyright (c) 2005-2007 Transmission authors and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *****************************************************************************/

#ifndef TR_PREF_WIND
#define TR_PREF_WIND

#include <stdlib.h>
#include <stdio.h>

#include <Button.h>
#include <TextControl.h>
#include <Slider.h>
#include <Window.h>
#include <Beep.h>
#include <Box.h>
#include <Font.h>
#include <String.h>
#include <TabView.h>
#include <View.h>
#include <CheckBox.h>

#include "TRApplication.h"
#include "Prefs.h"

#include "TRDefault.h"

class TRPrefsWindow : public BWindow {
public:
	TRPrefsWindow();
	~TRPrefsWindow();
	virtual void MessageReceived(BMessage *msg);
	virtual void Show();

private:
	void ReadPrefs();
	void SetDefaults();
	bool WritePrefs();
	
	BBox *_boxGeneral, *_boxTransfer, *_boxBandwidth, *_boxNetwork;
	BTabView *_tabView;
	BView *_trprefview, *_general, *_transfer, *_bandwidth, *_network;	
	BTextControl *_txtFolder, *_txtPort, *_txtTotalDownload, *_txtTotalUpload;
	BButton *_btnSave, *_btnCancel, *_btnDefaults;
};

#endif /* TR_PREF_WIND */
